"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _event() {
  const data = require("../../../../../nuclide-commons/event");

  _event = function () {
    return data;
  };

  return data;
}

function _UniversalDisposable() {
  const data = _interopRequireDefault(require("../../../../../nuclide-commons/UniversalDisposable"));

  _UniversalDisposable = function () {
    return data;
  };

  return data;
}

var React = _interopRequireWildcard(require("react"));

var _rxjsCompatUmdMin = require("rxjs-compat/bundles/rxjs-compat.umd.min.js");

function _DebuggerSteppingComponent() {
  const data = _interopRequireDefault(require("./DebuggerSteppingComponent"));

  _DebuggerSteppingComponent = function () {
    return data;
  };

  return data;
}

function _constants() {
  const data = require("../constants");

  _constants = function () {
    return data;
  };

  return data;
}

function _DebuggerControllerView() {
  const data = _interopRequireDefault(require("./DebuggerControllerView"));

  _DebuggerControllerView = function () {
    return data;
  };

  return data;
}

function _DebuggerAddTargetButton() {
  const data = require("./DebuggerAddTargetButton");

  _DebuggerAddTargetButton = function () {
    return data;
  };

  return data;
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright (c) 2017-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 *  strict-local
 * @format
 */
class DebuggerControlsView extends React.PureComponent {
  constructor(props) {
    super(props);
    this._disposables = new (_UniversalDisposable().default)();
    this.state = {
      mode: _constants().DebuggerMode.STOPPED
    };
  }

  componentDidMount() {
    const {
      service
    } = this.props;

    this._disposables.add(_rxjsCompatUmdMin.Observable.merge((0, _event().observableFromSubscribeFunction)(service.onDidChangeProcessMode.bind(service)), (0, _event().observableFromSubscribeFunction)(service.viewModel.onDidChangeDebuggerFocus.bind(service.viewModel))).startWith(null).subscribe(() => {
      const {
        viewModel
      } = this.props.service;
      const {
        focusedProcess
      } = viewModel;
      this.setState({
        mode: focusedProcess == null ? _constants().DebuggerMode.STOPPED : focusedProcess.debuggerMode
      });
    }));
  }

  componentWillUnmount() {
    this._dispose();
  }

  _dispose() {
    this._disposables.dispose();
  }

  render() {
    const {
      service
    } = this.props;
    const {
      mode
    } = this.state;
    const debuggerStoppedNotice = mode !== _constants().DebuggerMode.STOPPED ? null : React.createElement("div", {
      className: "debugger-pane-content"
    }, React.createElement("div", {
      className: "debugger-state-notice"
    }, "The debugger is not attached."), React.createElement("div", {
      className: "debugger-state-notice"
    }, (0, _DebuggerAddTargetButton().AddTargetButton)('debugger-buttongroup-center')));

    const running = mode === _constants().DebuggerMode.RUNNING;

    const paused = mode === _constants().DebuggerMode.PAUSED;

    const debuggerRunningNotice = !running && !paused ? null : React.createElement("div", {
      className: "debugger-pane-content"
    }, React.createElement("div", {
      className: "debugger-state-notice"
    }, (service.viewModel.focusedProcess == null || service.viewModel.focusedProcess.configuration.processName == null ? 'The debug target' : service.viewModel.focusedProcess.configuration.processName) + ` is ${running ? 'running' : 'paused'}.`));
    return React.createElement("div", {
      className: "debugger-container-new"
    }, React.createElement("div", {
      className: "debugger-section-header"
    }, React.createElement(_DebuggerControllerView().default, {
      service: service
    })), React.createElement("div", {
      className: "debugger-section-header debugger-controls-section"
    }, React.createElement(_DebuggerSteppingComponent().default, {
      service: service
    })), debuggerRunningNotice, debuggerStoppedNotice);
  }

}

exports.default = DebuggerControlsView;